## ros-dashing-rviz-rendering 6.1.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rviz_rendering)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic -Werror)
endif()

# Tests currently only run on OS X @ OSRF jenkins
# Enable on Linux by providing a display, enable on Windows via EnableDisplayTests=True
option(EnableDisplayTests "EnableDisplayTests")
set(DisplayTests "False" CACHE STRING "DisplayTestsVariable")

if(DEFINED ENV{DISPLAY})
  set(DISPLAYPRESENT TRUE)
endif()

if(APPLE OR DISPLAYPRESENT OR EnableDisplayTests STREQUAL "True")
  message(STATUS "Enabling tests requiring a display")
else()
  set(SKIP_DISPLAY_TESTS "SKIP_TEST")
endif()

find_package(ament_cmake REQUIRED)

# Qt5 boilerplate options from http://doc.qt.io/qt-5/cmake-manual.html
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

# do find_package(rviz_ogre_vendor) first to make sure the custom OGRE is found
find_package(rviz_ogre_vendor REQUIRED)
find_package(rviz_assimp_vendor REQUIRED)

find_package(Qt5 REQUIRED COMPONENTS Widgets)

find_package(ament_index_cpp REQUIRED)
find_package(eigen3_cmake_module REQUIRED)
find_package(Eigen3 REQUIRED)
find_package(resource_retriever REQUIRED)

# TODO(wjwwood): this block is to setup the windeployqt tool, could be removed later.
if(Qt5_FOUND AND WIN32 AND TARGET Qt5::qmake AND NOT TARGET Qt5::windeployqt)
  get_target_property(_qt5_qmake_location Qt5::qmake IMPORTED_LOCATION)

  execute_process(
    COMMAND "${_qt5_qmake_location}" -query QT_INSTALL_PREFIX
    RESULT_VARIABLE return_code
    OUTPUT_VARIABLE qt5_install_prefix
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  set(imported_location "${qt5_install_prefix}/bin/windeployqt.exe")

  if(EXISTS ${imported_location})
    add_executable(Qt5::windeployqt IMPORTED)

    set_target_properties(Qt5::windeployqt PROPERTIES
      IMPORTED_LOCATION ${imported_location}
    )
  endif()
endif()

# These need to be added in the add_library() call so AUTOMOC detects them.
set(headers_with_q_object
  include/rviz_rendering/render_window.hpp
)

add_library(rviz_rendering SHARED
  ${headers_with_q_object}
  src/rviz_rendering/apply_visibility_bits.cpp
  src/rviz_rendering/geometry.cpp
  src/rviz_rendering/viewport_projection_finder.cpp
  src/rviz_rendering/logging.cpp
  src/rviz_rendering/material_manager.cpp
  src/rviz_rendering/mesh_loader.cpp
  src/rviz_rendering/ogre_logging.cpp
  src/rviz_rendering/ogre_render_window_impl.cpp
  src/rviz_rendering/orthographic.cpp
  src/rviz_rendering/render_system.cpp
  src/rviz_rendering/render_window.cpp
  src/rviz_rendering/resource_config.cpp
  src/rviz_rendering/mesh_loader_helpers/stl_loader.cpp
  src/rviz_rendering/mesh_loader_helpers/assimp_loader.cpp
  src/rviz_rendering/string_helper.cpp
  src/rviz_rendering/objects/arrow.cpp
  src/rviz_rendering/objects/axes.cpp
  src/rviz_rendering/objects/billboard_line.cpp
  src/rviz_rendering/objects/covariance_visual.cpp
  src/rviz_rendering/objects/grid.cpp
  src/rviz_rendering/objects/line.cpp
  src/rviz_rendering/objects/movable_text.cpp
  src/rviz_rendering/objects/object.cpp
  src/rviz_rendering/objects/point_cloud.cpp
  src/rviz_rendering/objects/point_cloud_renderable.cpp
  src/rviz_rendering/objects/shape.cpp
  test/rviz_rendering/ogre_testing_environment.cpp
  test/rviz_rendering/scene_graph_introspection.cpp
)

target_link_libraries(rviz_rendering
  rviz_ogre_vendor::OgreMain
  rviz_ogre_vendor::OgreOverlay
  Qt5::Widgets
  ament_index_cpp::ament_index_cpp
  resource_retriever::resource_retriever
)

target_include_directories(rviz_rendering
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
    ${OGRE_INCLUDE_DIRS}
    ${Eigen3_INCLUDE_DIRS}
)
# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(rviz_rendering PRIVATE "RVIZ_RENDERING_BUILDING_LIBRARY")

ament_export_interfaces(rviz_rendering)
ament_target_dependencies(rviz_rendering
  rviz_assimp_vendor
)
ament_export_dependencies(
  rviz_ogre_vendor
  eigen3_cmake_module
  Eigen3
  resource_retriever
  ament_index_cpp)

ament_export_include_directories(include)
ament_export_libraries(rviz_rendering)

install(
  TARGETS rviz_rendering
  EXPORT rviz_rendering
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  INCLUDES DESTINATION include
  RUNTIME DESTINATION bin
)

install(
  DIRECTORY include/
  DESTINATION include
)

set(rviz_rendering_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src/cmake")
include(${CMAKE_CURRENT_SOURCE_DIR}/src/cmake/register_rviz_ogre_media_exports_hook-extras.cmake)

install(DIRECTORY src/cmake
  DESTINATION share/${PROJECT_NAME})

install(DIRECTORY "${CMAKE_SOURCE_DIR}/ogre_media"
  DESTINATION "share/${PROJECT_NAME}"
  USE_SOURCE_PERMISSIONS)

if(BUILD_TESTING)
  # TODO(wjwwood): replace this with ament_lint_auto() and/or add the copyright linter back
  find_package(ament_cmake_cppcheck REQUIRED)
  find_package(ament_cmake_cpplint REQUIRED)
  find_package(ament_cmake_lint_cmake REQUIRED)
  find_package(ament_cmake_uncrustify REQUIRED)
  ament_cppcheck()
  ament_cpplint()
  ament_lint_cmake()
  ament_uncrustify()

  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)

  ament_add_gmock(string_helper_test test/rviz_rendering/string_helper_test.cpp)
  if(TARGET string_helper_test)
    target_link_libraries(string_helper_test rviz_rendering)
  endif()

  ament_add_gmock(point_cloud_test_target
    test/rviz_rendering/objects/point_cloud_test.cpp
    ${SKIP_DISPLAY_TESTS})
  if(TARGET point_cloud_test_target)
    target_link_libraries(point_cloud_test_target
      rviz_ogre_vendor::OgreMain
      rviz_rendering
      Qt5::Widgets  # explicitly do this for include directories (not necessary for external use)
    )
  endif()

  ament_add_gmock(point_cloud_renderable_test_target
    test/rviz_rendering/objects/point_cloud_renderable_test.cpp
    ${SKIP_DISPLAY_TESTS})
  if(TARGET point_cloud_renderable_test_target)
    target_link_libraries(point_cloud_renderable_test_target
      rviz_ogre_vendor::OgreMain
      rviz_rendering
      Qt5::Widgets  # explicitly do this for include directories (not necessary for external use)
    )
  endif()

  ament_add_gmock(billboard_line_test_target
    test/rviz_rendering/objects/billboard_line_test.cpp
    ${SKIP_DISPLAY_TESTS})
  if(TARGET billboard_line_test_target)
    target_link_libraries(billboard_line_test_target
      rviz_ogre_vendor::OgreMain
      rviz_rendering
      Qt5::Widgets  # explicitly do this for include directories (not necessary for external use)
    )
  endif()

  ament_add_gmock(covariance_visual_test_target
    test/rviz_rendering/objects/covariance_visual_test.cpp
    ${SKIP_DISPLAY_TESTS})
  if(TARGET covariance_visual_test_target)
    target_link_libraries(covariance_visual_test_target
      rviz_ogre_vendor::OgreMain
      rviz_rendering
      Qt5::Widgets  # explicitly do this for include directories (not necessary for external use)
    )
  endif()

  ament_add_gmock(grid_test_target
    test/rviz_rendering/objects/grid_test.cpp
    ${SKIP_DISPLAY_TESTS})
  if(TARGET grid_test_target)
    target_link_libraries(grid_test_target
      rviz_ogre_vendor::OgreMain
      rviz_rendering
      Qt5::Widgets  # explicitly do this for include directories (not necessary for external use)
    )
  endif()

  ament_add_gmock(movable_text_test_target
    test/rviz_rendering/objects/movable_text_test.cpp
    ${SKIP_DISPLAY_TESTS})
  if(TARGET movable_text_test_target)
    target_link_libraries(movable_text_test_target
      rviz_ogre_vendor::OgreMain
      rviz_ogre_vendor::OgreOverlay
      rviz_rendering
      Qt5::Widgets
    )
  endif()

  ament_add_gmock(line_test_target
    test/rviz_rendering/objects/line_test.cpp
    ${SKIP_DISPLAY_TESTS})
  if(TARGET line_test_target)
    target_link_libraries(line_test_target
      rviz_ogre_vendor::OgreMain
      rviz_rendering
      Qt5::Widgets  # explicitly do this for include directories (not necessary for external use)
    )
  endif()
endif()

list(APPEND ${PROJECT_NAME}_CONFIG_EXTRAS
  "${CMAKE_CURRENT_SOURCE_DIR}/src/cmake/register_rviz_ogre_media_exports_hook-extras.cmake"
  "${CMAKE_CURRENT_SOURCE_DIR}/src/cmake/register_rviz_ogre_media_exports.cmake")

ament_package()

=== debian/changelog ===
ros-dashing-rviz-rendering (6.1.8-1bionic) bionic; urgency=high

  * Prevent rviz_rendering::AssimpLoader from loading materials twice. (#628 <https://github.com/ros2/rviz/issues/628>)
  * Contributors: Michel Hidalgo

 -- Jacob Perron <jacob@openrobotics.org>  Fri, 21 May 2021 07:00:00 -0000

ros-dashing-rviz-rendering (6.1.7-1bionic) bionic; urgency=high

  * Update maintainers. (#617 <https://github.com/ros2/rviz/issues/617>)
  * Contributors: Michael Jeronimo

 -- Jacob Perron <jacob@openrobotics.org>  Tue, 24 Nov 2020 08:00:00 -0000

ros-dashing-rviz-rendering (6.1.6-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Wed, 11 Mar 2020 07:00:00 -0000

ros-dashing-rviz-rendering (6.1.5-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Tue, 10 Dec 2019 08:00:00 -0000

ros-dashing-rviz-rendering (6.1.4-1bionic) bionic; urgency=high

  * Updated to use new ``eigen3_cmake_module``. (#441 <https://github.com/ros2/rviz/issues/441>) (#452 <https://github.com/ros2/rviz/issues/452>)
  * Contributors: Shane Loretz

 -- Jacob Perron <jacob@openrobotics.org>  Fri, 06 Sep 2019 07:00:00 -0000

ros-dashing-rviz-rendering (6.1.3-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Wed, 31 Jul 2019 07:00:00 -0000

ros-dashing-rviz-rendering (6.1.2-1bionic) bionic; urgency=high

  * Fixed a bug in the STL loader where an STL would be loaded twice and produce an error. (#410 <https://github.com/ros2/rviz/issues/410>)
    * Also fixed a warning about a missing material, by adding BaseWhiteNoLighting to the ``rviz_rendering`` resource group.
    * Previous to Ogre 1.11, materials would be searched in all groups With 1.11, this is no longer true.
    * In RViz, we try to put materials in our own resource group, but we need the Ogre fallback material.
  * Contributors: Martin Idel

 -- Jacob Perron <jacob@openrobotics.org>  Wed, 12 Jun 2019 07:00:00 -0000

ros-dashing-rviz-rendering (6.1.1-1bionic) bionic; urgency=high

  * Fixed the installation destination of OGRE media resources which contain a ``dirname`` (#404 <https://github.com/ros2/rviz/issues/404>)
  * Contributors: Dirk Thomas

 -- Jacob Perron <jacob@openrobotics.org>  Wed, 29 May 2019 07:00:00 -0000

ros-dashing-rviz-rendering (6.1.0-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Mon, 20 May 2019 07:00:00 -0000

ros-dashing-rviz-rendering (6.0.0-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Wed, 08 May 2019 07:00:00 -0000

ros-dashing-rviz-rendering (5.1.0-1bionic) bionic; urgency=high

  * Handle FindEigen3 module's differing definitions (#370 <https://github.com/ros2/rviz/issues/370>)
  * Contributors: Scott K Logan

 -- Jacob Perron <jacob@openrobotics.org>  Mon, 14 Jan 2019 08:00:00 -0000

ros-dashing-rviz-rendering (5.0.0-1bionic) bionic; urgency=high

  * Export libraries to trigger hooks. (#358 <https://github.com/ros2/rviz/issues/358>)
  * Added virtual destructors for WindowManagerInterface and ViewportProjectionFinder (#356 <https://github.com/ros2/rviz/issues/356>)
  * Increased visual testing stability (#344 <https://github.com/ros2/rviz/issues/344>)
  * Cleanup dependencies for rviz_rendering_tests (#326 <https://github.com/ros2/rviz/issues/326>)
  * Changed to always build all tests and skip execution if not supported (#342 <https://github.com/ros2/rviz/issues/342>)
  * Changed to support uncrustify 0.67 (#333 <https://github.com/ros2/rviz/issues/333>)
    * fix closing block and tamplete indentation to comply with uncrustify 0.67
    * add space between reference and variable name
    * space before opening bracket
    * fix indend of inherited class
    * fix indent of code blocks
    * no space around -> operator
    * restore original spacing
  * Contributors: Andreas Greimel, Kartik Mohta, Mikael Arguedas, Steven! Ragnarök, William Woodall

 -- Jacob Perron <jacob@openrobotics.org>  Tue, 04 Dec 2018 08:00:00 -0000

ros-dashing-rviz-rendering (4.0.1-1bionic) bionic; urgency=high

  * move find_package or test dependencies to test block (#331 <https://github.com/ros2/rviz/issues/331>)
  * Contributors: William Woodall

 -- Jacob Perron <jacob@openrobotics.org>  Thu, 28 Jun 2018 07:00:00 -0000

ros-dashing-rviz-rendering (4.0.0-1bionic) bionic; urgency=high

  * Fixed the dependecy name for ``eigen``. (#324 <https://github.com/ros2/rviz/issues/324>)
  * Fixed bugs causing rviz to crash on macOS. (#319 <https://github.com/ros2/rviz/issues/319>)
    * Fix Ogre assertion failure on Mac on resizing an Image or Camera display render window.
    * Fix segfault on Mac when resizing window after a Camera or Image Display was removed.
  * Introduced visual testing framework for rviz. (#209 <https://github.com/ros2/rviz/issues/209>)
  * Restored the use of icons throughout rviz. (#235 <https://github.com/ros2/rviz/issues/235>)
  * Migrated the Path display. (#236 <https://github.com/ros2/rviz/issues/236>)
  * Migrated the marker display. (#229 <https://github.com/ros2/rviz/issues/229>)
  * Migrated RobotModel display. (#210 <https://github.com/ros2/rviz/issues/210>)
  * Changed to allow Ogre to delete its own render windows. (#195 <https://github.com/ros2/rviz/issues/195>)
  * Fixed compilation errors and runtime issues on Windows. (#175 <https://github.com/ros2/rviz/issues/175>)
  * Fixed a memory leak. (#173 <https://github.com/ros2/rviz/issues/173>)
    * Signed-off-by: Chris Ye <mailto:chris.ye@intel.com>
  * Refactored the Grid display. (#165 <https://github.com/ros2/rviz/issues/165>)
  * Remove now obsolete function. (#163 <https://github.com/ros2/rviz/issues/163>)
    * It was made obsolete by pr #136 <https://github.com/ros2/rviz/issues/136> which removed the memcopy.
  * Contributors: Alessandro Bottero, Andreas Greimel, Andreas Holzner, Dirk Thomas, Martin Idel, Mikael Arguedas, Steven! Ragnarök, William Woodall

 -- Jacob Perron <jacob@openrobotics.org>  Wed, 27 Jun 2018 07:00:00 -0000



=== debian/control ===
Source: ros-dashing-rviz-rendering
Section: misc
Priority: optional
Maintainer: Jacob Perron <jacob@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, qtbase5-dev, ros-dashing-ament-cmake, ros-dashing-ament-cmake-cppcheck, ros-dashing-ament-cmake-cpplint, ros-dashing-ament-cmake-gmock, ros-dashing-ament-cmake-gtest, ros-dashing-ament-cmake-lint-cmake, ros-dashing-ament-cmake-uncrustify, ros-dashing-ament-index-cpp, ros-dashing-eigen3-cmake-module, ros-dashing-resource-retriever, ros-dashing-rviz-assimp-vendor, ros-dashing-rviz-ogre-vendor, ros-dashing-ros-workspace
Homepage: https://github.com/ros2/rviz/blob/ros2/README.md
Standards-Version: 3.9.2

Package: ros-dashing-rviz-rendering
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libqt5core5a, libqt5gui5, libqt5opengl5, libqt5widgets5, qtbase5-dev, ros-dashing-ament-index-cpp, ros-dashing-eigen3-cmake-module, ros-dashing-resource-retriever, ros-dashing-rviz-assimp-vendor, ros-dashing-rviz-ogre-vendor, ros-dashing-ros-workspace
Description: Library which provides the 3D rendering functionality in rviz.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/dashing/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/dashing" \
		-DAMENT_PREFIX_PATH="/opt/ros/dashing" \
		-DCMAKE_PREFIX_PATH="/opt/ros/dashing"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-dashing-rviz-rendering//opt/ros/dashing/lib/:$(CURDIR)/debian/ros-dashing-rviz-rendering//opt/ros/dashing/opt/rviz_assimp_vendor/lib/:$(CURDIR)/debian/ros-dashing-rviz-rendering//opt/ros/dashing/opt/rviz_ogre_vendor/lib/:$(CURDIR)/debian/ros-dashing-rviz-rendering//opt/ros/dashing/opt/rviz_yaml_cpp_vendor/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/dashing/setup.sh" ]; then . "/opt/ros/dashing/setup.sh"; fi && \
	dh_auto_install
